SystemOrganization addCategory: #'Volunti-ElectionManager-Model'!
SystemOrganization addCategory: #'Volunti-ElectionManager-View'!
SystemOrganization addCategory: #'Volunti-ElectionManager-Tests'!

VOEntry subclass: #CryptographyHelper
	instanceVariableNames: 'numberOfWitnesses rsaKeyLength paillierKeyLength numberOfBallots hashFunction mentalBoothKeySize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

!CryptographyHelper class methodsFor: 'defaults' stamp: 'NicolasVanderAuwera 5/5/2012 14:44'!
defaultNumberOfWitnesses
	^ 5! !

!CryptographyHelper class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/30/2012 14:33'!
hashFunction
	^ SHA256! !

!CryptographyHelper class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/5/2012 14:37'!
maxNumberOfBallots
	^ 2! !

!CryptographyHelper class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/9/2012 13:31'!
paillierKeyLength
	^ 128! !

!CryptographyHelper class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/30/2012 14:35'!
rsaKeyLength
	^ 1024! !

!CryptographyHelper methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 16:02'!
descriptionHashFunction
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #hashFunction;
		label: 'Hash function';
		comment: 'The function used by the system to hash messages.';
		options:
				(HashFunction allSubclasses
						remove: SHA256;
						remove: MD5;
						yourself);
		yourself! !

!CryptographyHelper methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 16:25'!
descriptionMentalBoothKeySize
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #mentalBoothKeySize;
		label: 'Mental booth key size';
		options: (5 to: 10);
		yourself! !

!CryptographyHelper methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 16:22'!
descriptionNumberOfBallots
	<magritteDescription>
	^ MANumberDescription new
		accessor: #numberOfBallots;
		label: 'Number of ballots';
		comment: 'The number of ballots that could be submitted by a voter.';
		beRequired;
		yourself! !

!CryptographyHelper methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 16:22'!
descriptionNumberOfWitnesses
	<magritteDescription>
	^ MANumberDescription new
		accessor: #numberOfWitnesses;
		label: 'Number of witnesses';
		comment: 'The number of witnesses involved in the elections.';
		beRequired;
		yourself! !

!CryptographyHelper methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 16:25'!
descriptionPaillierKeyLength
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #paillierKeyLength;
		label: 'Paillier key length';
		options: #(128 256 512 1024 2048 4096);
		default: 2048;
		yourself! !

!CryptographyHelper methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 16:25'!
descriptionRSAKeyLength
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #rsaKeyLength;
		label: 'RSA key length';
		options: #(128 256 512 1024 2048 4096);
		default: 2048;
		yourself! !

!CryptographyHelper methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:53'!
hashFunction
	^ hashFunction! !

!CryptographyHelper methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:53'!
hashFunction: anObject
	hashFunction := anObject! !

!CryptographyHelper methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/21/2012 09:24'!
initialize
	super initialize.
	numberOfWitnesses := 10.
	paillierKeyLength := rsaKeyLength := 2048.
	numberOfBallots := 5.
	hashFunction := SHA256NonPrimitive.
	mentalBoothKeySize := 5! !

!CryptographyHelper methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 09:24'!
mentalBoothKeySize
	^ mentalBoothKeySize! !

!CryptographyHelper methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 09:24'!
mentalBoothKeySize: anObject
	mentalBoothKeySize := anObject! !

!CryptographyHelper methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
numberOfBallots
	^ numberOfBallots! !

!CryptographyHelper methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
numberOfBallots: anObject
	numberOfBallots := anObject! !

!CryptographyHelper methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
numberOfWitnesses
	^ numberOfWitnesses! !

!CryptographyHelper methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
numberOfWitnesses: anObject
	numberOfWitnesses := anObject! !

!CryptographyHelper methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
paillierKeyLength
	^ paillierKeyLength! !

!CryptographyHelper methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
paillierKeyLength: anObject
	paillierKeyLength := anObject! !

!CryptographyHelper methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
rsaKeyLength
	^ rsaKeyLength! !

!CryptographyHelper methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:52'!
rsaKeyLength: anObject
	rsaKeyLength := anObject! !

VOEntry subclass: #Election
	instanceVariableNames: 'choices name id createdAt startDate endDate protocol numberOfChoices opened description regex'
	classVariableNames: 'Database Types'
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

Election class
	instanceVariableNames: 'id'!

!Election commentStamp: 'NicolasVanderAuwera 3/1/2012 07:14' prior: 0!
I am an election and I have my protocol.

Instance Variables:
	k -> number of choices that the voter has to select
	choices -> list of choices!

Election class
	instanceVariableNames: 'id'!

!Election class methodsFor: 'adding' stamp: 'NicolasVanderAuwera 10/27/2012 14:12'!
add: anElection
	self elections add: anElection! !

!Election class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/22/2012 09:52'!
description
	^ 'Choose 1 out of N'! !

!Election class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/27/2012 14:13'!
elections
	Database ifNil: [ Database := OrderedCollection new ].
	^ Database! !

!Election class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/7/2011 10:31'!
id
	id ifNil: [ id := 0 ].
	^ id := id + 1! !

!Election class methodsFor: 'removing' stamp: 'NicolasVanderAuwera 10/27/2012 14:13'!
remove: anElection
	self elections remove: anElection! !

!Election methodsFor: 'converting' stamp: 'NicolasVanderAuwera 12/7/2011 10:34'!
<= election
	^ self id <= election id! !

!Election methodsFor: 'adding' stamp: 'NicolasVanderAuwera 3/1/2012 07:21'!
addChoice: aString
	self addChoice: aString with: nil! !

!Election methodsFor: 'adding' stamp: 'NicolasVanderAuwera 3/1/2012 07:16'!
addChoice: aString with: anImage
	"if the choice has no image, pass nil"

	self choices
		add:
			(VOChoice new
				name: aString;
				image: anImage;
				yourself)! !

!Election methodsFor: 'converting' stamp: 'NicolasVanderAuwera 8/22/2012 14:29'!
asClientElection
	"concatenation of the election and its protocol"

	^ VOCElection
		name: self name
		choices: self choices
		createdAt: self createdAt
		ballotDesign: self ballot
		id: self id
		protocol: self protocol
		opened: self opened
		description: self description! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/7/2012 18:34'!
ballot
	^ VOBallot! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/27/2012 15:04'!
choices
	^ choices! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/27/2012 15:04'!
choices: aCollection
	choices := aCollection! !

!Election methodsFor: 'initialize-release' stamp: 'NicolasVanderAuwera 3/1/2012 11:12'!
clearChoices
	choices := nil! !

!Election methodsFor: 'validation' stamp: 'NicolasVanderAuwera 5/2/2012 08:31'!
close
	opened := false! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/4/2012 14:47'!
createdAt
	^ createdAt! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/28/2012 13:00'!
description
	^ description! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/28/2012 13:00'!
description: anObject
	description := anObject! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 14:45'!
descriptionChoices
	<magritteDescription>
	^ MAToManyRelationDescription new
		accessor: #choices;
		label: 'Choices';
		classes: (Array with: VOChoice);
		addCondition: [ :value | value notEmpty ] labelled: 'An election must have at least one choice';
		componentClass: VOOneToManyComponent;
		priority: 4;
		yourself! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/28/2012 10:51'!
descriptionContainer
	^ super descriptionContainer
		addCondition: [ :memento | 
					(memento cache at: self descriptionStartDate) isNil
						or: [ (memento cache at: self descriptionEndDate) > (memento cache at: self descriptionStartDate) ] ]
			labelled: 'End date must be after start date';
		yourself! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/28/2012 05:49'!
descriptionEndDate
	<magritteDescription>
	^ MADateAndTimeDescription new
		accessor: #endDate;
		label: 'End date';
		priority: 3;
		comment: 'Indicate the end date of the election.';
		addCondition: [ :value | value > Date today ] labelled: 'The end date must be greater than today';
		yourself! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 15:58'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		priority: 1;
		comment: 'Please enter the name of the election.';
		beRequired;
		yourself! !

!Election methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/28/2012 05:48'!
descriptionStartDate
	<magritteDescription>
	^ MADateAndTimeDescription new
		accessor: #startDate;
		label: 'Start date';
		priority: 2;
		addCondition: [ :value | value > Date today ] labelled: 'The start date must be greater than today';
		comment: 'Indicate the start date of the election.';
		yourself! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:12'!
endDate
	^ endDate! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:12'!
endDate: anObject
	endDate := anObject! !

!Election methodsFor: 'user interface' stamp: 'NicolasVanderAuwera 8/18/2012 09:22'!
fields
	^ #(#name #description #numberOfChoices #regex #startDate #endDate)! !

!Election methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/1/2012 10:34'!
hasValidChoices
	^ self numberOfChoices notNil and: [ self numberOfChoices > 0 ]! !

!Election methodsFor: 'validation' stamp: 'NicolasVanderAuwera 12/13/2011 17:29'!
hasValidName
	^ self name notEmpty! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/7/2011 10:20'!
id
	^ id! !

!Election methodsFor: 'initialize-release' stamp: 'NicolasVanderAuwera 10/27/2012 14:08'!
initialize
	super initialize.
	createdAt := DateAndTime now.
	id := self class id.
	name := ''.
	opened := false.
	description := ''.
	choices := OrderedCollection new.
	regex := '[0-9][0-9].[0-9][0-9].[0-9][0-9]-[0-9][0-9][0-9].[0-9][0-9]'! !

!Election methodsFor: 'user interface' stamp: 'NicolasVanderAuwera 8/18/2012 09:26'!
labelOf: aSymbol
	aSymbol == #choices
		ifTrue: [ ^ 'Choices' ].
	aSymbol == #property
		ifTrue: [ ^ 'Property' ].
	aSymbol == #name
		ifTrue: [ ^ 'Name' ].
	aSymbol == #startDate
		ifTrue: [ ^ 'Start Date' ].
	aSymbol == #endDate
		ifTrue: [ ^ 'End Date' ].
	aSymbol == #protocol
		ifTrue: [ ^ 'Protocol' ].
	aSymbol == #numberOfChoices
		ifTrue: [ ^ 'Number of choices' ].
	aSymbol == #regex
		ifTrue: [ ^ 'National Number Regex' ].
	^ aSymbol! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/28/2012 10:47'!
legend
	^ 'All elections of the system are listed below.'! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/7/2011 10:36'!
name
	^ name! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/7/2011 10:36'!
name: aString
	name := aString! !

!Election methodsFor: 'validation' stamp: 'NicolasVanderAuwera 3/1/2012 10:19'!
numberOfChoices
	^ numberOfChoices! !

!Election methodsFor: 'validation' stamp: 'NicolasVanderAuwera 3/1/2012 10:19'!
numberOfChoices: anInteger
	numberOfChoices := anInteger! !

!Election methodsFor: 'public' stamp: 'NicolasVanderAuwera 5/2/2012 08:31'!
open
	opened := true! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/2/2012 09:35'!
opened
	^ opened! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 08:09'!
protocol
	^ protocol! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 08:09'!
protocol: anObject
	protocol := anObject! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/20/2012 11:53'!
regex
	^ regex! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/18/2012 09:22'!
regex: anObject
	regex := anObject! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:12'!
startDate
	^ startDate! !

!Election methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/7/2012 07:12'!
startDate: anObject
	startDate := anObject! !

!Election methodsFor: 'validation' stamp: 'NicolasVanderAuwera 8/20/2012 11:56'!
validate
	self hasValidChoices
		ifFalse: [ WAValidationNotification signal: 'The number of choices field is not valid.' ].
	self hasValidName
		ifFalse: [ WAValidationNotification signal: 'You must provide a name for the election' ].
	(self startDate notNil and: [ self endDate notNil ])
		ifTrue: [ 
			self startDate < self endDate
				ifFalse: [ WAValidationNotification signal: 'The start date must be less than the end date.' ] ]! !

!Election methodsFor: 'validation' stamp: 'NicolasVanderAuwera 3/1/2012 11:05'!
validateChoices
	self choices do: [ :choice | choice validate ].
	self choices size > self numberOfChoices
		ifTrue: [ WAValidationNotification signal: 'You entered too much choices.' ].
	self choices size < self numberOfChoices
		ifTrue: [ WAValidationNotification signal: 'You didn''t enter enough choices.' ]! !

Election subclass: #KOutOfNElection
	instanceVariableNames: 'maxNumberOfAllowedChoices'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

!KOutOfNElection commentStamp: 'NicolasVanderAuwera 11/8/2011 07:49' prior: 0!
Choose K out of N (when a voter cast his vote, it should be with only k value to 1)!

!KOutOfNElection class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/22/2012 09:52'!
description
	^ 'Choose K out of N'! !

!KOutOfNElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/7/2012 18:34'!
ballot
	^ VOKOutOfNBallot! !

!KOutOfNElection methodsFor: 'user interface' stamp: 'NicolasVanderAuwera 11/28/2011 14:43'!
fields
	^ #(maxNumberOfAllowedChoices) union: super fields
	! !

!KOutOfNElection methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/1/2012 10:36'!
hasValidMaxNumberOfAllowedChoices
	^ self numberOfChoices >= self maxNumberOfAllowedChoices! !

!KOutOfNElection methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/18/2011 16:23'!
isMaxNumberAnInteger
	^ (self maxNumberOfAllowedChoices greaseInteger) isInteger! !

!KOutOfNElection methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/18/2011 16:23'!
isMaxNumberGreaterThanZero
	^ self maxNumberOfAllowedChoices greaseInteger > 0! !

!KOutOfNElection methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/1/2012 07:45'!
isMaxNumberNotEmpty
	^ self maxNumberOfAllowedChoices notNil! !

!KOutOfNElection methodsFor: 'user interface' stamp: 'NicolasVanderAuwera 11/20/2011 07:21'!
labelOf: aSymbol
	aSymbol == #maxNumberOfAllowedChoices
		ifTrue: [ ^ 'Maximum number of allowed choices' ].
	^ super labelOf: aSymbol! !

!KOutOfNElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/15/2011 08:12'!
maxNumberOfAllowedChoices
	^ maxNumberOfAllowedChoices! !

!KOutOfNElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/17/2011 11:20'!
maxNumberOfAllowedChoices: aNumber
	maxNumberOfAllowedChoices := aNumber! !

!KOutOfNElection methodsFor: 'validation' stamp: 'NicolasVanderAuwera 11/18/2011 16:11'!
validate
	super validate.
	self isMaxNumberNotEmpty
		ifFalse: [ WAValidationNotification signal: 'You must provide a maximum number of allowed choices' ].
	self isMaxNumberAnInteger
		ifFalse: [ WAValidationNotification signal: 'The maximum number of allowed choices must be an integer' ].
	self isMaxNumberGreaterThanZero
		ifFalse: [ WAValidationNotification signal: 'The maximum number of allowed choices must be greater than 0' ].
	self hasValidMaxNumberOfAllowedChoices
		ifFalse: [ WAValidationNotification signal: 'The maximum number of allowed choices is greater than the number of possible choices' ]! !

KOutOfNElection subclass: #MPtKOutOfNElection
	instanceVariableNames: 'pointsToDistribute'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

!MPtKOutOfNElection class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/22/2012 09:53'!
description
	^ 'Distribute M points to K out of N with possible equality'! !

!MPtKOutOfNElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/7/2012 18:34'!
ballot
	^ VOMPtKOutOfNBallot! !

!MPtKOutOfNElection methodsFor: 'user interface' stamp: 'NicolasVanderAuwera 11/28/2011 14:43'!
fields
	^ #(maxNumberOfAllowedChoices pointsToDistribute) union: super fields! !

!MPtKOutOfNElection methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/1/2012 07:48'!
isPointsToDistributeAnInteger
	^ self pointsToDistribute isInteger! !

!MPtKOutOfNElection methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/1/2012 07:48'!
isPointsToDistributeGreaterThanZero
	^ self pointsToDistribute > 0! !

!MPtKOutOfNElection methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/1/2012 07:48'!
isPointsToDistributeNotEmpty
	^ self pointsToDistribute notNil! !

!MPtKOutOfNElection methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/10/2012 10:21'!
isRemainingPointsToDistribute
	^ self pointsToDistribute > 0! !

!MPtKOutOfNElection methodsFor: 'user interface' stamp: 'NicolasVanderAuwera 11/20/2011 07:21'!
labelOf: aSymbol
	aSymbol == #pointsToDistribute
		ifTrue: [ ^ 'Points to distribute' ].
	^ super labelOf: aSymbol! !

!MPtKOutOfNElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2011 07:19'!
pointsToDistribute
	^ pointsToDistribute! !

!MPtKOutOfNElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/20/2011 07:19'!
pointsToDistribute: anObject
	pointsToDistribute := anObject! !

!MPtKOutOfNElection methodsFor: 'validation' stamp: 'NicolasVanderAuwera 8/20/2012 11:58'!
validate
	super validate.
	self isPointsToDistributeNotEmpty
		ifFalse: [ WAValidationNotification signal: 'You must provide a number of points to distribute' ].
	self isPointsToDistributeAnInteger
		ifFalse: [ WAValidationNotification signal: 'The number of points to distribute must be an integer' ].
	self isPointsToDistributeGreaterThanZero
		ifFalse: [ WAValidationNotification signal: 'The number of points to distribute must be greater than 0' ]! !

Election subclass: #MBElection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

MBElection subclass: #AlternativeMBElection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

!AlternativeMBElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 13:36'!
ballot
	^ VOMBAlternativeBallot! !

!MBElection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/7/2012 09:17'!
ballot
	^ VOMBBallot! !

VOManagerPage subclass: #VOEMMainAreaPage
	instanceVariableNames: 'electionsList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOEMMainAreaPage methodsFor: 'adding' stamp: 'NicolasVanderAuwera 10/27/2012 14:45'!
addElection
	| election |
	election := self call: Election new asComponent.
	election ifNotNil: [ :arg | Election add: election ]! !

!VOEMMainAreaPage methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 1/27/2012 11:04'!
children
	^ Array with: self electionsList! !

!VOEMMainAreaPage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/11/2012 07:13'!
configurationTaskClass
	^ VOSystemConfigurationTask! !

!VOEMMainAreaPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/27/2012 14:16'!
createElectionTask
	"	self agent configurationCheck.
	self agent isConfigured
		ifTrue: [ self agent addElection: (self call: VOElectionCreationTask new) ]
		ifFalse: [ self inform: 'Some agents are misconfigured. Please verify your configuration befor creating a new election.' ]"

	Election add: (self call: Election new asComponent)! !

!VOEMMainAreaPage methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/27/2012 15:03'!
electionsList
	electionsList isNil
		ifTrue: [ electionsList := VOEMElectionsListPage elections: Election elections ].
	^ electionsList! !

!VOEMMainAreaPage methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/22/2012 14:44'!
initialize
	super initialize.
	login := VOLoginPageView new! !

!VOEMMainAreaPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 10:49'!
renderCreateOn: html
	html anchor
		class: 'btn btn-success';
		callback: [ 
					"self createElectionTask"
					self addElection ];
		with: 'New election'! !

!VOEMMainAreaPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/27/2012 16:23'!
renderCryptographicEditorOn: html
	html anchor
		class: 'btn btn-danger';
		callback: [ self call: agent cryptography asComponent ];
		with: 'Modify cryptographic parameters'! !

!VOEMMainAreaPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/2/2012 14:04'!
renderElectionsListOn: html
	html render: self electionsList! !

!VOEMMainAreaPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 15:34'!
renderMainContentOn: html
	self session isAdmin
		ifFalse: [ html render: login ].
	super renderMainContentOn: html! !

!VOEMMainAreaPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 10:49'!
renderRestrictedContentOn: html
	self renderElectionsListOn: html.
	html div
		class: 'form-actions form-horizontal';
		with: [ 
					self renderCreateOn: html.
					html space.
					self renderCryptographicEditorOn: html.
					html space.
					self renderConfigureAnchorText: 'Check system' On: html ]! !

!VOEMMainAreaPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/20/2012 08:50'!
reset
	self agent reset! !

VOAgentComponent subclass: #VOElectionManagerComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionManagerComponent class methodsFor: 'class initialization' stamp: 'NicolasVanderAuwera 5/5/2012 07:27'!
initialize
	super initialize.
	self register! !

!VOElectionManagerComponent class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/27/2011 13:25'!
url
	^ 'electionmanager'! !

!VOElectionManagerComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/9/2011 07:45'!
agentClass
	^ VOElectionManager! !

!VOElectionManagerComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/22/2012 14:39'!
main
	^ VOEMMainAreaPage! !

!VOElectionManagerComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/27/2011 12:59'!
title
	^ 'Election Manager'! !

WATask subclass: #VOElectionClosureTask
	instanceVariableNames: 'election'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionClosureTask class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 4/9/2012 11:31'!
election: anElection
	^ self new election: anElection! !

!VOElectionClosureTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 5/2/2012 09:45'!
actionTask: protocol
	protocol close: election with: VOElectionManager current configurations.
	election close! !

!VOElectionClosureTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/9/2012 11:31'!
election: anElection
	election := anElection! !

!VOElectionClosureTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 10/29/2012 10:04'!
go
	| protocol |
	protocol := (VOEMProtocol protocolWithKey: election protocol) new.
	self actionTask: protocol.
	self call: (VOLogComponent log: protocol log anchor: 'Continue')! !

VOElectionClosureTask subclass: #VOElectionOpeningTask
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionOpeningTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 5/2/2012 09:48'!
actionTask: protocol
	protocol open: election with: VOElectionManager current configurations.
	election open! !

WATask subclass: #VOElectionCreationTask
	instanceVariableNames: 'protocol selection election'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionCreationTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 3/1/2012 10:32'!
editChoices
	self call: (VOChoicesEditor election: election)! !

!VOElectionCreationTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 4/9/2012 10:37'!
editElection
	self call: (VOElectionEditor election: election)! !

!VOElectionCreationTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 4/9/2012 10:36'!
electionChoice
	election := self call: (VOElectionSelection list: protocol electionTypes)! !

!VOElectionCreationTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 10/28/2012 06:06'!
go
	self protocolChoice.
	self call: election asComponent.
	election protocol: protocol class key.
	protocol isSimple
		ifTrue: [ election open ].
	protocol systemInitializationWith: election with: VOElectionManager current configurations.
	self showLog: protocol log.
	self answer: election! !

!VOElectionCreationTask methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 10/28/2012 06:05'!
initialize
	super initialize.
	election := Election new.
	selection := VOExtendedChoiceDialog options: VOEMProtocol withAllSubclasses! !

!VOElectionCreationTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/22/2012 10:07'!
protocol: aProtocol
	protocol := aProtocol! !

!VOElectionCreationTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 4/9/2012 10:36'!
protocolChoice
	protocol := (self call: selection) new! !

!VOElectionCreationTask methodsFor: 'tasks' stamp: 'NicolasVanderAuwera 10/29/2012 10:04'!
showLog: anOrderedCollection
	self call: (VOLogComponent log: anOrderedCollection anchor: 'Continue')! !

WATask subclass: #VOSystemConfigurationTask
	instanceVariableNames: 'manager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOSystemConfigurationTask class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 5/5/2012 11:31'!
manager: aManager
	^ self new manager: aManager! !

!VOSystemConfigurationTask methodsFor: 'running' stamp: 'NicolasVanderAuwera 10/28/2012 07:03'!
go
	[ 
	self call: manager asComponent.
	self call: (VOSystemConfigurationCheck model: manager).
	manager isConfigured ] whileFalse! !

!VOSystemConfigurationTask methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 11:32'!
manager: aManager
	manager := aManager! !

GRObject subclass: #VOChoice
	instanceVariableNames: 'id name image'
	classVariableNames: 'Id'
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

!VOChoice class methodsFor: 'accessing instances and variables' stamp: 'NicolasVanderAuwera 11/19/2011 14:07'!
id
	Id isNil
		ifTrue: [ Id := 0 ].
	^ Id := Id + 1! !

!VOChoice class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 11/16/2011 09:42'!
name: aString
	^ self new
		name: aString;
		id: self id;
		yourself! !

!VOChoice methodsFor: 'comparing' stamp: 'NicolasVanderAuwera 3/1/2012 07:25'!
<= aChoice
	^ self id < aChoice id! !

!VOChoice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/1/2012 07:09'!
assertNatural: anId
	self assert: anId isInteger.
	self assert: anId > 0! !

!VOChoice methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 14:06'!
descriptionImage
	<magritteDescription>
	^ MAFileDescription new
		accessor: #image;
		label: 'Image';
		priority: 1;
		yourself! !

!VOChoice methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/27/2012 14:08'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		priority: 2;
		comment: 'Indicate the name of the candidate.';
		beRequired;
		yourself! !

!VOChoice methodsFor: 'testing' stamp: 'NicolasVanderAuwera 1/19/2012 09:08'!
hasAnImage
	^ image notNil! !

!VOChoice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/16/2011 08:27'!
id
	^ id! !

!VOChoice methodsFor: 'private' stamp: 'NicolasVanderAuwera 3/1/2012 07:09'!
id: anId
	self assertNatural: anId.
	id := anId! !

!VOChoice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/19/2012 08:52'!
image
	^ image! !

!VOChoice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/19/2012 08:52'!
image: anObject
	image := anObject! !

!VOChoice methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 11/20/2011 14:10'!
initialize
	super initialize.
	id := 0.
	name := ''! !

!VOChoice methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/1/2012 07:10'!
isChoice
	^ true! !

!VOChoice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/16/2011 08:29'!
name
	^ name! !

!VOChoice methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/15/2011 11:13'!
name: aString
	self assert: aString isString.
	name := aString! !

!VOChoice methodsFor: 'validation' stamp: 'NicolasVanderAuwera 3/1/2012 10:24'!
validate
	self name notEmpty
		ifFalse: [ WAValidationNotification signal: 'Each choice must have a name.' ]! !

GRObject subclass: #VOEMProtocol
	instanceVariableNames: 'agents configured log'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

VOEMProtocol subclass: #VOEMAnonymousProtocol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

!VOEMAnonymousProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/27/2012 14:23'!
description
	^ 'Provides the following properties: anonymity'! !

!VOEMAnonymousProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/27/2012 11:01'!
key
	^ 'anonymous'! !

!VOEMAnonymousProtocol methodsFor: 'opening' stamp: 'NicolasVanderAuwera 7/23/2012 07:40'!
close: anElection with: configurations
	super close: anElection with: configurations.
	self sendElection: anElection toPB: (configurations at: VOPublicBoardManager key)! !

!VOEMAnonymousProtocol methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 7/23/2012 07:40'!
initialize
	super initialize.
	agents := agents , (Array with: VOAnonymousManager with: VORegistrationOfficeManager with: VOPublicBoardManager)! !

!VOEMAnonymousProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 5/5/2012 08:47'!
isSimple
	^ false! !

!VOEMAnonymousProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/2/2012 08:58'!
sendElection: election toPB: config
	| stream |
	stream := SocketStream openConnectionToHostNamed: config host port: config port.
	stream sendCommand: #election.
	stream sendObject: election.
	stream close! !

VOEMAnonymousProtocol subclass: #VOEMMentalBoothProtocol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

VOEMMentalBoothProtocol subclass: #VOEMAlternativeMBProtocol
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

!VOEMAlternativeMBProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 09:00'!
description
	^ 'The interface displays m values that the voter has to bind to candidates, including the voter''s secret key'! !

!VOEMAlternativeMBProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 08:58'!
key
	^ 'alternative'! !

!VOEMAlternativeMBProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 11:01'!
ballot
	^ VOMBAlternativeBallot! !

!VOEMAlternativeMBProtocol methodsFor: 'elections' stamp: 'NicolasVanderAuwera 5/8/2012 13:37'!
electionTypes
	^ Array with: AlternativeMBElection! !

!VOEMMentalBoothProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/27/2012 14:24'!
description
	^ 'Provides the following properties: anonymity, coercion-resistance, receipt-freeness'! !

!VOEMMentalBoothProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/27/2012 11:01'!
key
	^ 'mentalbooth'! !

!VOEMMentalBoothProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/21/2012 10:06'!
ballot
	^ VOMBBallot! !

!VOEMMentalBoothProtocol methodsFor: 'elections' stamp: 'NicolasVanderAuwera 4/7/2012 18:47'!
electionTypes
	^ Array with: MBElection! !

!VOEMMentalBoothProtocol methodsFor: 'initialize-release' stamp: 'NicolasVanderAuwera 7/23/2012 07:40'!
initialize
	super initialize.
	agents := agents
		,
			(Array
				with: VOMentalBoothManager
				with: VOMPDVSManager
				with: VOWitnessManager
				with: VOHomomorphicManager)! !

!VOEMProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 08:53'!
description
	^ 'No property is supported.'! !

!VOEMProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/16/2012 08:52'!
key
	^ 'simple'! !

!VOEMProtocol class methodsFor: 'searching' stamp: 'NicolasVanderAuwera 4/9/2012 11:44'!
protocolWithKey: aSymbol
	^ self withAllSubclasses detect: [ :protocolClass | protocolClass key = aSymbol ]! !

!VOEMProtocol class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/27/2012 14:22'!
title
	^ self key capitalized! !

!VOEMProtocol methodsFor: 'private' stamp: 'NicolasVanderAuwera 4/7/2012 18:46'!
addInLog: msg
	self log add: msg.
	self triggerEvent: 'systemLogRefreshed'! !

!VOEMProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/17/2012 08:50'!
agents
	^ agents! !

!VOEMProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 2/16/2012 08:25'!
ballot
	^ nil! !

!VOEMProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 2/4/2012 15:31'!
checkSystem
	| errors |
	errors := false.
	agents
		do: [ :config | 
			[ config testConnection ]
				on: Error
				do: [ :err | errors := true ] ].
	configured := errors not! !

!VOEMProtocol methodsFor: 'opening' stamp: 'NicolasVanderAuwera 5/2/2012 13:14'!
close: anElection with: configurations
	self addInLog: 'Closure of the election named ' , anElection name.
	self agents
		do: [ :agent | 
			self addInLog: 'The agent ' , agent title , ' is closing the election.'.
			self sendElectionId: anElection id config: (configurations at: agent key) message: 'close'.
			self addInLog: 'The agent ' , agent title , ' has correctly closed the election.' ]! !

!VOEMProtocol methodsFor: 'elections' stamp: 'NicolasVanderAuwera 4/7/2012 18:48'!
electionTypes
	^ Array with: Election with: KOutOfNElection with: MPtKOutOfNElection! !

!VOEMProtocol methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 7/23/2012 07:39'!
initialize
	super initialize.
	log := VOLog new.
	configured := false.
	agents := Array with: VOPollingOfficeManager! !

!VOEMProtocol methodsFor: 'system-initialization' stamp: 'NicolasVanderAuwera 5/8/2012 08:57'!
initializeAgent: configuration with: anElection
	| aStream |
	aStream := SocketStream openConnectionToHostNamed: configuration host port: configuration port.
	aStream
		sendCommand: 'initialization';
		sendCommand: anElection id greaseString;
		sendCommand: anElection name;
		sendCommand: self class key;
		sendCommand: anElection numberOfChoices greaseString.
	aStream close! !

!VOEMProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/4/2012 15:10'!
isConfigured
	^ configured! !

!VOEMProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 5/5/2012 08:47'!
isSimple
	^ true! !

!VOEMProtocol methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/7/2012 18:49'!
log
	^ log! !

!VOEMProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 2/4/2012 15:13'!
notConfigured
	^ configured not! !

!VOEMProtocol methodsFor: 'opening' stamp: 'NicolasVanderAuwera 5/2/2012 13:14'!
open: anElection with: configurations
	self addInLog: 'Opening of the election named ' , anElection name.
	self agents
		do: [ :agent | 
			self addInLog: 'The agent ' , agent title , ' is opening the election.'.
			self sendElectionId: anElection id config: (configurations at: agent key) message: 'open'.
			self addInLog: 'The agent ' , agent title , ' has correctly opened the election.' ]! !

!VOEMProtocol methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/2/2012 10:55'!
sendElectionId: anId config: config  message: msg
	| stream |
	stream := SocketStream openConnectionToHostNamed: config host port: config port.
	stream sendCommand: msg.
	stream sendCommand: anId greaseString.
	stream close! !

!VOEMProtocol methodsFor: 'system-initialization' stamp: 'NicolasVanderAuwera 4/27/2012 10:03'!
systemInitializationWith: anElection with: configurations
	agents
		do: [ :agent | 
			self addInLog: 'Initialization of ' , agent title , '...'.
			self initializeAgent: (configurations at: agent key) with: anElection.
			self addInLog: agent title , ' is correctly initialized.' ]! !

!VOEMProtocol methodsFor: 'validation' stamp: 'NicolasVanderAuwera 1/18/2012 15:31'!
validate
	self validateConfigurations! !

!VOEMProtocol methodsFor: 'testing' stamp: 'NicolasVanderAuwera 1/18/2012 09:42'!
validateConfigurations
	self agents do: [ :config | config validate ]! !

VOElectionsListComponent subclass: #VOEMElectionsListPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOEMElectionsListPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/27/2012 15:14'!
renderClose: election on: html
	html anchor
		class: 'btn btn-error';
		callback: [ self call: (VOElectionClosureTask election: election) ];
		with: 'Close'! !

!VOEMElectionsListPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/27/2012 15:21'!
renderDetailsOf: election on: html
	html anchor
		callback: [ self call: election asComponent ];
		with: 'View Details'! !

!VOEMElectionsListPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/2/2012 09:49'!
renderMoreData: election on: html
	html tableData: [ self renderDetailsOf: election on: html ].
	html tableData
		class: 'opened' if: election opened;
		with: [ 
					election opened
						ifTrue: [ self renderClose: election on: html ]
						ifFalse: [ self renderOpen: election on: html ] ].
	election startDate isNil
		ifTrue: [ html tableData: 'None' ]
		ifFalse: [ html tableData: election startDate asDate ].
	election endDate isNil
		ifTrue: [ html tableData: 'None' ]
		ifFalse: [ html tableData: election endDate asDate ]! !

!VOEMElectionsListPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 4/9/2012 14:36'!
renderMoreDataHeadingOn: html
	html tableHeading: 'Details'.
	html tableHeading: 'Action'.
	html tableHeading: 'Start Date'.
	html tableHeading: 'End Date'! !

!VOEMElectionsListPage methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/27/2012 15:13'!
renderOpen: election on: html
	html anchor
		class: 'btn btn-success';
		callback: [ self call: (VOElectionOpeningTask election: election) ];
		with: 'Open'! !

WAComponent subclass: #VOChoicesEditor
	instanceVariableNames: 'inputType election'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOChoicesEditor class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 3/1/2012 10:12'!
election: anElection
	^ self new election: anElection! !

!VOChoicesEditor methodsFor: 'testing' stamp: 'NicolasVanderAuwera 3/1/2012 10:31'!
addFormByDefault
	^ false! !

!VOChoicesEditor methodsFor: 'rendering-elements' stamp: 'NicolasVanderAuwera 3/1/2012 11:12'!
commaStringToCollection: value
	election clearChoices.
	(value subStrings: ', ') do: [ :choice | election addChoice: choice ]! !

!VOChoicesEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/1/2012 10:12'!
election: anElection
	election := anElection! !

!VOChoicesEditor methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 3/1/2012 10:37'!
initialize
	super initialize.
	inputType := #TextInputs.
	self validateWith: [ :answer | answer validateChoices ].
	self addMessage: 'Fill the different choices'! !

!VOChoicesEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 3/10/2012 10:52'!
receiveFile: aFile to: aChoice
	| stream |
	stream := (FileDirectory default directoryNamed: 'uploads')
		assureExistence;
		forceNewFileNamed: aFile fileName;
		yourself.
	[ 
	stream
		binary;
		nextPutAll: aFile rawContents.
	aChoice image: aFile ]
		ensure: [ stream close ]! !

!VOChoicesEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 3/1/2012 11:13'!
renderContentOn: html
	self renderSwitchAnchorOn: html.
	self renderNumberOfInputsOn: html.
	html break.
	html
		form: [ 
			self renderInputTypeOn: html.
			html submitButton callback: [ self answer: election ] ]! !

!VOChoicesEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/9/2012 07:58'!
renderInputTypeOn: html
	| renderSelector |
	renderSelector := self renderingSelectorFor: inputType.
	self perform: renderSelector with: html 
	! !

!VOChoicesEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 3/1/2012 10:41'!
renderNumberOfInputsOn: html
	html
		paragraph: [ 
			html strong: 'Number of choices: '.
			html span
				id: 'nbinputs';
				with: election numberOfChoices ]! !

!VOChoicesEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/9/2012 07:50'!
renderSwitchAnchorOn: html
	html anchor
		callback: [ self toggleView ];
		with: 'Switch view'! !

!VOChoicesEditor methodsFor: 'rendering-elements' stamp: 'NicolasVanderAuwera 3/5/2012 14:46'!
renderTextAreaOn: html
	html textArea
		rows: 10;
		callback: [ :value | self commaStringToCollection: value ];
		value: election choices asCommaString.
	html break! !

!VOChoicesEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 3/5/2012 14:39'!
renderTextInputWith: aNumber on: html
	| choice |
	html div
		id: html nextId;
		with: [ 
					html span: aNumber greaseString , '.'.
					html space.
					html textInput callback: [ :value | choice := election addChoice: value ].
					html space.
					html fileUpload callback: [ :value | self receiveFile: value to: choice ].
					html break ]! !

!VOChoicesEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 3/1/2012 11:12'!
renderTextInputsOn: html
	html div
		id: #inputs;
		with: [ 1 to: election numberOfChoices do: [ :i | self renderTextInputWith: i on: html ] ]! !

!VOChoicesEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/9/2012 07:56'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'On:') asSymbol! !

!VOChoicesEditor methodsFor: 'testing' stamp: 'NicolasVanderAuwera 1/20/2012 09:13'!
toggleView
	inputType := inputType = #TextArea
		ifTrue: [ #TextInputs ]
		ifFalse: [ #TextArea ]! !

WAComponent subclass: #VOElectionSelection
	instanceVariableNames: 'list'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionSelection class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 1/22/2012 10:08'!
list: electionsList
	^ self new list: electionsList! !

!VOElectionSelection methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/22/2012 10:08'!
list: aList
	list := aList! !

!VOElectionSelection methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/22/2012 10:08'!
renderContentOn: html
	html div
		class: 'container';
		with: [ 
					self renderTitleOn: html.
					self renderInformationOn: html.
					html
						form: [ 
							html select
								list: list;
								labels: [ :election | election description ];
								callback: [ :election | self answer: election new ].
							html submitButton with: 'Confirm' ] ]! !

!VOElectionSelection methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2011 14:35'!
renderInformationOn: html
	html paragraph
		class: 'info';
		with: 'You must select the election mode. Click on "Confirm" button to continue.'! !

!VOElectionSelection methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 12/6/2011 16:17'!
renderTitleOn: html
	html heading
		level: 3;
		with: 'Choice the election'! !

WAComponent subclass: #VOElectionView
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionView class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 1/7/2012 11:45'!
model: anElection
	^ self new model: anElection! !

!VOElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/7/2012 13:37'!
labelOf: aSymbol
	^ self model labelOf: aSymbol! !

!VOElectionView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/7/2012 11:50'!
model
	^ model! !

!VOElectionView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/7/2012 11:45'!
model: aModel
	model := aModel! !

!VOElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/7/2012 13:39'!
renderBackOn: html
	html anchor
		callback: [ self answer ];
		with: 'Back'! !

!VOElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/21/2012 07:26'!
renderChoicesOn: html
	self model choices
		do: [ :choice | 
			html div
				class: 'choice';
				with: [ 
							choice hasAnImage
								ifTrue: [ 
									| image |
									image := choice image.
									html image
										document: image mimeType: image contentType fileName: image fileName;
										altText: 'Halo-Paint' ].
							html span: choice name ] ]! !

!VOElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/7/2012 13:40'!
renderContentOn: html
	self renderTitleOn: html.
	html table: [ self model fields do: [ :field | self renderField: field on: html ] ].
	self renderBackOn: html! !

!VOElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/7/2012 13:05'!
renderDefaultFieldForSelector: aSymbol on: html
	html text: (self model perform: aSymbol)! !

!VOElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/7/2012 13:31'!
renderField: aSymbol on: html
	html
		tableRow: [ 
			html tableData: [ self renderLabelOf: aSymbol on: html ].
			html tableData: [ self renderFieldForSelector: aSymbol on: html ] ]! !

!VOElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/7/2012 11:41'!
renderFieldForSelector: aSymbol on: html
	| renderSelector |
	renderSelector := self renderingSelectorFor: aSymbol.
	(self respondsTo: renderSelector)
		ifTrue: [ self perform: renderSelector with: html ]
		ifFalse: [ self renderDefaultFieldForSelector: aSymbol on: html ]! !

!VOElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/22/2012 14:27'!
renderLabelOf: aSymbol on: html
	html strong: (self labelOf: aSymbol) capitalized! !

!VOElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/7/2012 13:41'!
renderTitleOn: html
	html heading level: 2; with: self model name! !

!VOElectionView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/7/2012 11:41'!
renderingSelectorFor: aSymbol
	^ ('render', aSymbol capitalized, 'On:') asSymbol! !

WAComponent subclass: #VOSystemConfigurationCheck
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOSystemConfigurationCheck class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 1/17/2012 11:32'!
model: aProtocol
	^ self new model: aProtocol! !

!VOSystemConfigurationCheck methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/17/2012 11:32'!
model
	^ model! !

!VOSystemConfigurationCheck methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/17/2012 11:32'!
model: anObject
	model := anObject! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 10:45'!
renderActionsOn: html
	html div
		class: 'form-actions';
		with: [ 
					self renderCheckOn: html.
					html space.
					self renderBackOn: html.
					self renderTerminateOn: html ]! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 10:44'!
renderBackOn: html
	html anchor
		class: 'btn';
		callback: [ self answer: false ];
		with: 'Back'! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 10:44'!
renderCheckOn: html
	html anchor
		class: 'btn btn-info';
		callback: [ self model check ];
		with: 'Check'! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 5/5/2012 16:12'!
renderConfig: config on: html
	^ html
		paragraph: [ 
			html text: 'The ' , config description , ' is '.
			config isConfigured
				ifTrue: [ 
					html text: 'correctly configured.'. html break.
					html text: 'It is listenning on port '.
					html strong: config port ]
				ifFalse: [ 
					html text: 'misconfigured.'.
					html break.
					html strong: ' Message: '.
					html text: config errorMsg ] ]! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 10:41'!
renderContentOn: html
	self renderInformationOn: html.
	self model configurations
		keysAndValuesDo: [ :agent :config | 
			html div
				class: 'alert alert-success' if: config isConfigured;
				class: 'alert alert-danger' if: config notConfigured;
				with: [ self renderConfig: config on: html ] ].
	self renderActionsOn: html! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 10:39'!
renderInformationOn: html
	self model isConfigured
		ifFalse: [ 
			html div
				class: 'alert alert-info';
				with: [ 
							html
								paragraph:
									'All agents must be correctly configured before the election is created. Click on the back anchor in the bottom of the page to reconfigure agents.' ] ].
	html horizontalRule! !

!VOSystemConfigurationCheck methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/28/2012 10:45'!
renderTerminateOn: html
	self model isConfigured
		ifTrue: [ 
			html space.
			html anchor
				class: 'btn btn-success';
				callback: [ self answer: true ];
				with: 'Terminate' ]! !

WAComponent subclass: #VOSystemInitializationView
	instanceVariableNames: 'protocol'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOSystemInitializationView class methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 4/9/2012 10:44'!
initializeSystemWith: aProtocol
	| initializer |
	initializer := self new protocol: aProtocol! !

!VOSystemInitializationView methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 4/9/2012 10:47'!
protocol: aProtocol
	protocol := aProtocol! !

!VOSystemInitializationView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 4/9/2012 10:45'!
renderContentOn: html
	self renderLogOn: html! !

!VOSystemInitializationView methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 4/9/2012 10:47'!
renderLogOn: html
	html textArea
		readonly: true;
		value: protocol log! !

WALabelledFormDialog subclass: #VOCryptographicParametersEditor
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOCryptographicParametersEditor class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 8/2/2012 14:00'!
cryptography: anObject
	^ self new model: anObject! !

!VOCryptographicParametersEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:54'!
buttons
	^ #(#save)! !

!VOCryptographicParametersEditor methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 8/21/2012 09:26'!
initialize
	super initialize.
	self addMessage: 'Cryptographic parameters'! !

!VOCryptographicParametersEditor methodsFor: 'as yet unclassified' stamp: 'NicolasVanderAuwera 8/21/2012 09:34'!
labelForSelector: aSymbol
	aSymbol = #numberOfBallots
		ifTrue: [ ^ 'Number of Challenges (including the real ballot)' ].
	^ super labelForSelector: aSymbol! !

!VOCryptographicParametersEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 14:00'!
model
	^ model! !

!VOCryptographicParametersEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 14:00'!
model: anObject
	model := anObject! !

!VOCryptographicParametersEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/22/2012 08:00'!
renderHashFunctionOn: html
	html select
		list:
				(HashFunction allSubclasses
						remove: SHA256;
						remove: MD5;
						yourself);
		selected: SHA256NonPrimitive;
		callback: [ :value | model hashFunction: value ]! !

!VOCryptographicParametersEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/21/2012 09:25'!
rows
	^ #(#numberOfWitnesses #rsaKeyLength #paillierKeyLength #numberOfBallots #hashFunction #mentalBoothKeySize)! !

!VOCryptographicParametersEditor methodsFor: 'actions' stamp: 'NicolasVanderAuwera 8/18/2012 08:06'!
save
	self answer: model! !

WALabelledFormDialog subclass: #VOElectionEditor
	instanceVariableNames: 'election inputView numberOfInputs choicesView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOElectionEditor class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 4/9/2012 10:37'!
election: anElection
	^ self new election: anElection! !

!VOElectionEditor methodsFor: 'actions' stamp: 'NicolasVanderAuwera 1/19/2012 09:23'!
addForm
	form := WAVOFormDecoration new buttons: self buttons.
	self addDecoration: form! !

!VOElectionEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/28/2011 14:41'!
buttons
	^ #(create)! !

!VOElectionEditor methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 2/20/2012 11:24'!
children
	^ Array with: choicesView! !

!VOElectionEditor methodsFor: 'actions' stamp: 'NicolasVanderAuwera 3/1/2012 10:33'!
create
	self answer: election! !

!VOElectionEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 12/13/2011 07:17'!
divClass
	^ 'inputs'! !

!VOElectionEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/17/2011 10:06'!
election: anElection
	election := anElection! !

!VOElectionEditor methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 3/1/2012 10:11'!
initialize
	super initialize.
	choicesView := VOChoicesEditor new.
	self validateWith: [ :anElection | anElection validate ].
	self addMessage: 'Please enter the following information'! !

!VOElectionEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/28/2012 12:59'!
labelForSelector: aSymbol
	aSymbol == #create
		ifTrue: [ ^ 'Create' ].
	aSymbol == #cancel
		ifTrue: [ ^ 'Cancel' ].
	aSymbol == #property
		ifTrue: [ ^ 'Property' ].
	aSymbol == #name
		ifTrue: [ ^ 'Name' ].
	aSymbol == #startDate
		ifTrue: [ ^ 'Start Date' ].
	aSymbol == #endDate
		ifTrue: [ ^ 'End Date' ].
	aSymbol == #description
		ifTrue: [ ^ 'Description' ].
	^ election labelOf: aSymbol! !

!VOElectionEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/17/2011 10:06'!
model
	^ election! !

!VOElectionEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 7/28/2012 13:33'!
renderChoicesInformationOn: html
	html paragraph: 'The choices will be show randomly for voters.'! !

!VOElectionEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 7/28/2012 13:33'!
renderChoicesOn: html
	self renderChoicesInformationOn: html.
	html render: choicesView! !

!VOElectionEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 7/28/2012 13:02'!
renderDescriptionOn: html
	(html textArea)
		on: #description of: election;
		value: election description greaseString! !

!VOElectionEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/20/2012 11:42'!
renderEndDateOn: html
	html textInput
		value: election endDate;
		callback: [ :value | 
					value isEmpty
						ifFalse: [ election endDate: value asDate ] ];
		script: (html jQuery new datepicker onSelect: html jQuery ajax serializeThis)! !

!VOElectionEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 3/1/2012 10:18'!
renderMaxNumberOfAllowedChoicesOn: html
	html textInput
		callback: [ :value | election maxNumberOfAllowedChoices: value greaseInteger ];
		value: election maxNumberOfAllowedChoices! !

!VOElectionEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 3/1/2012 10:21'!
renderNumberOfChoicesOn: html
	html textInput
		callback: [ :value | election numberOfChoices: value greaseInteger ];
		value: election numberOfChoices! !

!VOElectionEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/20/2011 07:57'!
renderPointsToDistributeOn: html
	html numberInput
		on: #pointsToDistribute of: election;
		value: election pointsToDistribute! !

!VOElectionEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 8/18/2012 09:24'!
renderRegexOn: html
	html textInput
		callback: [ :value | election regex: value ];
		value: election regex! !

!VOElectionEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 2/20/2012 11:43'!
renderStartDateOn: html
	html textInput
		value: election startDate;
		callback: [ :value | 
					value isEmpty
						ifFalse: [ election startDate: value asDate ] ];
		script: (html jQuery new datepicker onSelect: html jQuery ajax serializeThis)! !

!VOElectionEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 7/28/2012 13:33'!
renderTextAreaOn: html
	self renderChoicesInformationOn: html.
	html textArea
		rows: 10;
		on: #choices of: election;
		value: election choices greaseString.
	html break! !

!VOElectionEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 11/21/2011 15:06'!
renderTitleOn: html
	html heading level: 1; with: 'Create the election'! !

!VOElectionEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 11/17/2011 10:22'!
rows
	^ election fields! !

!VOElectionEditor methodsFor: 'testing' stamp: 'NicolasVanderAuwera 1/9/2012 07:42'!
toggleView! !

!VOElectionEditor methodsFor: 'testing' stamp: 'NicolasVanderAuwera 11/17/2011 07:03'!
validate
	" Only called when cancel is call, so nothing to validate "

	^ true! !

WALabelledFormDialog subclass: #VOSystemConfigurationEditor
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOSystemConfigurationEditor class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 2/4/2012 15:27'!
model: aProtocol
	^ self new model: aProtocol! !

!VOSystemConfigurationEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 7/30/2012 14:22'!
buttons
	^ #(continue clear)! !

!VOSystemConfigurationEditor methodsFor: 'actions' stamp: 'NicolasVanderAuwera 7/30/2012 14:22'!
clear
	VOElectionManager current clearConfigurations! !

!VOSystemConfigurationEditor methodsFor: 'actions' stamp: 'NicolasVanderAuwera 1/18/2012 08:45'!
continue
	self answer: self model! !

!VOSystemConfigurationEditor methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 2/4/2012 15:53'!
initialize
	super initialize.
	self validateWith: [ :aProtocol | aProtocol validate ]! !

!VOSystemConfigurationEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/18/2012 08:37'!
model
	^ model! !

!VOSystemConfigurationEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/17/2012 10:36'!
model: aModel
	model := aModel! !

!VOSystemConfigurationEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 7/30/2012 10:20'!
renderConfigurationOn: html
	self model configurations
		do: [ :config | 
			html
				fieldSet: [ 
					self renderDescription: config on: html.
					self renderHost: config on: html.
					self renderPort: config on: html ] ]! !

!VOSystemConfigurationEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 7/30/2012 10:41'!
renderDescription: config on: html
	(html image)
		class: 'server';
		url: (VOFileLibrary urlOf: #serverPng).
	(html heading)
		level: 3;
		with: config description! !

!VOSystemConfigurationEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 7/30/2012 10:25'!
renderHost: config on: html
	html label
		for: html nextId;
		with: 'Host'.
	html textInput
		id: html lastId;
		placeholder: 'Enter the hostname of the agent';
		callback: [ :value | config host: value ];
		value: config host! !

!VOSystemConfigurationEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 7/30/2012 10:25'!
renderPort: config on: html
	html label
		for: html nextId;
		with: 'Port'.
	html textInput
		id: html lastId;
		placeholder: 'Enter the port of the agent';
		callback: [ :value | config port: value greaseInteger ];
		value: config port! !

!VOSystemConfigurationEditor methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/29/2012 16:34'!
renderPortsOn: html
	html
		paragraph:
			'PO : ' , VOPollingOfficeManager port greaseString , ' | MB : ' , VOMentalBoothManager port greaseString
				, ' | MPDVS : ' , VOMPDVSManager port greaseString , ' | AA : ' , VOAnonymousManager port greaseString
				, ' | PB : ' , VOPublicBoardManager port greaseString , ' | RO : '
				, VORegistrationOfficeManager port greaseString , ' | WA : ' , VOWitnessManager port greaseString , ' | ID :  '
				, VOIDGenerationServer port greaseString , ' | KGS : ' , VOKeyGenerationServer port greaseString , ' | CA : '
				, VOCertificationAuthority port greaseString , ' | HA : ' , VOHomomorphicManager port greaseString! !

!VOSystemConfigurationEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 2/4/2012 16:00'!
rows
	^ #(configuration ports)! !

!VOSystemConfigurationEditor methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 13:48'!
style
	^ 'fieldset {border: 1px solid lightgrey; padding: 5px; border-radius: 5px;} .dialog-form-label {font-weight:bold;}'! !

TestCase subclass: #ElectionTest
	instanceVariableNames: 'anElection emptyElection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Tests'!

!ElectionTest methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/1/2012 07:22'!
choices
	^ #('Nicolas' 'Jerome' 'Smith' 'Thomas' 'Amlie' 'Jean' 'Christine')! !

!ElectionTest methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 3/1/2012 07:39'!
name
	^ 'test'! !

!ElectionTest methodsFor: 'running' stamp: 'NicolasVanderAuwera 4/7/2012 18:09'!
setUp
	anElection := Election new
		numberOfChoices: self choices size;
		name: self name;
		protocol: VOEMProtocol new;
		yourself.
	self choices do: [ :choice | anElection addChoice: choice ].
	emptyElection := Election new name: self name! !

!ElectionTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 8/20/2012 11:50'!
testAsClientElection
	| clientElection |
	clientElection := anElection asClientElection .
	self assert: clientElection id = anElection id.
	self assert: 'simple' = anElection protocol class key! !

!ElectionTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 3/1/2012 07:23'!
testChoices
	self
		assert: ((OrderedCollection newFrom: self choices) includesAllOf: (anElection choices collect: [ :each | each name ]))! !

!ElectionTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 3/1/2012 07:23'!
testNewBallot
	! !

!ElectionTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 3/1/2012 15:17'!
testValidate
	self should: [ emptyElection validate ] raise: WAValidationNotification.
	self shouldnt: [ anElection validate ] raise: WAValidationNotification! !

ElectionTest subclass: #KOutOfNElectionTest
	instanceVariableNames: 'election2 election3 election4'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Tests'!

!KOutOfNElectionTest methodsFor: 'class membership' stamp: 'NicolasVanderAuwera 4/7/2012 18:09'!
ballotClassName
	^ KOutOfNElection! !

!KOutOfNElectionTest methodsFor: 'running' stamp: 'NicolasVanderAuwera 8/20/2012 11:56'!
setUp
	anElection := self ballotClassName new numberOfChoices: 3; maxNumberOfAllowedChoices: 2; yourself.
	election2 := self ballotClassName new numberOfChoices: 3; maxNumberOfAllowedChoices: self choices size + 1; yourself.
	election3 := self ballotClassName new numberOfChoices: 3; maxNumberOfAllowedChoices: -1; yourself.
	election4 := self ballotClassName new numberOfChoices: 3; maxNumberOfAllowedChoices: 'aString'; yourself.
	emptyElection := self ballotClassName new.
	self choices
		do: [ :choice | 
			anElection
				name: self name;
				addChoice: choice.
			election2
				name: self name;
				addChoice: choice.
			election3
				name: self name;
				addChoice: choice.
			election4
				name: self name;
				addChoice: choice ]! !

!KOutOfNElectionTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 11/20/2011 14:39'!
testValidate
	self shouldnt: [ anElection validate ] raise: WAValidationNotification.
	self should: [ election2 validate ] raise: WAValidationNotification.
	self should: [ election3 validate ] raise: WAValidationNotification.
	self should: [ election4 validate ] raise: WAValidationNotification! !

KOutOfNElectionTest subclass: #MPtKOutOfNElectionTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Tests'!

!MPtKOutOfNElectionTest methodsFor: 'class membership' stamp: 'NicolasVanderAuwera 4/7/2012 18:09'!
ballotClassName
	^ MPtKOutOfNElection! !

!MPtKOutOfNElectionTest methodsFor: 'running' stamp: 'NicolasVanderAuwera 4/7/2012 18:09'!
setUp
	super setUp.
	anElection pointsToDistribute: 2.
	election2 pointsToDistribute: 2.
	election3 pointsToDistribute: -1.
	election4 pointsToDistribute: 'aString'.
	emptyElection := MPtKOutOfNElection new! !

!MPtKOutOfNElectionTest methodsFor: 'tests' stamp: 'NicolasVanderAuwera 8/20/2012 11:58'!
testValidate
	self shouldnt: [ anElection validate ] raise: WAValidationNotification.
	self halt.
	self shouldnt: [ election2 validate ] raise: WAValidationNotification.
	self halt.
	self should: [ election3 validate ] raise: WAValidationNotification.
	self should: [ election4 validate ] raise: Error! !

WAChoiceDialog subclass: #VOExtendedChoiceDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-View'!

!VOExtendedChoiceDialog methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 1/18/2012 08:17'!
buttons
	^ #(ok)! !

!VOExtendedChoiceDialog methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 1/27/2012 15:09'!
renderContentOn: html
	html heading
		level: 2;
		with: 'Choose the protocol'.
	html paragraph
		id: html nextId;
		class: 'description';
		with: [ html text: self options first description ].
	html select
		list: self options;
		labels: [ :each | each title ];
		selected: self selection;
		callback: [ :value | self selection: value ];
		onChange: ((html jQuery: html lastId) load html: [ :h | h render: self selection description ])! !

VOCertifiedAgent subclass: #VOElectionManager
	instanceVariableNames: 'elections manager cryptography'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Volunti-ElectionManager-Model'!

VOElectionManager class
	instanceVariableNames: 'protocols'!

!VOElectionManager commentStamp: 'NicolasVanderAuwera 3/1/2012 07:13' prior: 0!
I contains the different Elections.

Instance Variables:
	elections	<(Collection of: VOElection)>

Class Instance Variables:
	protocols	<ProtoObject>!

VOElectionManager class
	instanceVariableNames: 'protocols'!

!VOElectionManager class methodsFor: 'x509' stamp: 'NicolasVanderAuwera 5/5/2012 15:56'!
organisationUnit
	^ 'Election Manager'! !

!VOElectionManager class methodsFor: 'network' stamp: 'NicolasVanderAuwera 12/1/2011 09:23'!
port
	^ 1234! !

!VOElectionManager class methodsFor: 'network' stamp: 'NicolasVanderAuwera 12/31/2011 11:41'!
protocols
	^ protocols
		ifNil: [ 
			protocols := Dictionary new
				at: #mentalbooth put: VOEMMentalBoothProtocol;
				at: #simple put: VOEMProtocol;
				at: #anonymous put: VOEMProtocol;
				yourself ]! !

!VOElectionManager methodsFor: 'adding' stamp: 'NicolasVanderAuwera 10/29/2012 14:58'!
addElection: anElection
	anElection
		when: #close
		send: #removeElection:
		to: self
		with: anElection.
	self elections add: anElection.
	self addInLog: 'A new election has been created'! !

!VOElectionManager methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 7/30/2012 14:30'!
clearConfigurations
	manager := VOConfigurationManager configurations: self initializeConfigurations! !

!VOElectionManager methodsFor: 'testing' stamp: 'NicolasVanderAuwera 5/11/2012 09:08'!
configurationCheck
	manager check! !

!VOElectionManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 16:15'!
configurations
	^ manager configurations! !

!VOElectionManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 8/2/2012 13:53'!
cryptography
	cryptography ifNil: [ cryptography := CryptographyHelper new ].
	^ cryptography! !

!VOElectionManager methodsFor: 'searching' stamp: 'NicolasVanderAuwera 3/1/2012 15:26'!
electionWithId: anId
	^ self elections detect: [ :election | election id = anId ] ifNone: [ nil ]! !

!VOElectionManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/8/2012 09:11'!
elections
	elections isNil
		ifTrue: [ elections := OrderedCollection new ].
	^ elections! !

!VOElectionManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 5/5/2012 08:04'!
electionsForNetwork
	"Answer all opened elections"

	^ self elections collect: [ :election | election asClientElection ]! !

!VOElectionManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 10/29/2012 16:46'!
handle: aMessage
	super handle: aMessage.
	aMessage command = #elections
		ifTrue: [ stream sendObject: self electionsForNetwork ].
	aMessage command = #election
		ifTrue: [ stream sendObject: (self electionWithId: stream nextLine greaseInteger) ].
	aMessage command = #configurations
		ifTrue: [ stream sendObject: self configurations ].
	aMessage command = #candidates
		ifTrue: [ self sendCandidates ].
	aMessage command = #parameters
		ifFalse: [ ^ self ].
	self sendParameters! !

!VOElectionManager methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 5/5/2012 11:27'!
initialize
	super initialize.
	manager := VOConfigurationManager configurations: self initializeConfigurations! !

!VOElectionManager methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 10/29/2012 16:34'!
initializeConfigurations
	| dictionary |
	dictionary := Dictionary new.
	VOManager allSubclasses
		do: [ :authority | dictionary at: authority key put: (VONetworkConfiguration description: authority organisationUnit key: authority key) ].
	dictionary
		at: VOIDGenerationServer key
		put: (VONetworkConfiguration description: VOIDGenerationServer organisationUnit key: VOIDGenerationServer key).
	dictionary
		at: VOKeyGenerationServer key
		put: (VONetworkConfiguration description: VOKeyGenerationServer organisationUnit key: VOKeyGenerationServer key).
	dictionary
		at: VOCertificationAuthority key
		put: (VONetworkConfiguration description: VOCertificationAuthority organisationUnit key: VOCertificationAuthority key).
	dictionary
		at: VOHomomorphicManager key
		put: (VONetworkConfiguration description: VOHomomorphicManager organisationUnit key: VOHomomorphicManager key).
	^ dictionary! !

!VOElectionManager methodsFor: 'testing' stamp: 'NicolasVanderAuwera 5/7/2012 10:10'!
isConfigured
	^ manager isConfigured! !

!VOElectionManager methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 5/5/2012 11:28'!
manager
	^ manager! !

!VOElectionManager methodsFor: 'removing' stamp: 'NicolasVanderAuwera 10/29/2012 14:58'!
removeElection: anElection
	self elections remove: anElection ifAbsent: [  ].
	self addInLog: 'The election named ' , anElection name, ' has been removed'! !

!VOElectionManager methodsFor: 'removing' stamp: 'NicolasVanderAuwera 2/16/2012 08:41'!
reset
	"close all available elections"

	self elections do: [ :election | election close ]! !

!VOElectionManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 10/29/2012 14:59'!
sendCandidates
	| election |
	election := self electionWithId: stream nextLine greaseInteger.
	stream sendObject: election choices.
	self addInLog: 'Candidates sent'! !

!VOElectionManager methodsFor: 'network' stamp: 'NicolasVanderAuwera 8/23/2012 06:57'!
sendParameters
	stream sendObject: cryptography! !
VOElectionManagerComponent initialize!
